/*============================================================================
  File:     Reading the histogram.sql

  Summary:  Another example for reading the histogram

  SQL Server Version: 2005-2012
------------------------------------------------------------------------------
  Written by Kimberly L. Tripp & Paul S. Randal, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended as a supplement to the SQL Server 2008 Jumpstart or
  Metro training.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

USE Credit
go

sp_helpindex member
go

sp_helpstats member
go

DBCC SHOW_STATISTICS ('member', 'member_corporation_link')
WITH HISTOGRAM
go

SELECT m.* 
FROM dbo.member AS m
WHERE m.corp_no = 403
go

SELECT m.* 
FROM dbo.member AS m
WHERE m.corp_no = 404
go

SELECT m.* 
FROM dbo.member AS m
WHERE m.corp_no = 405
go

SELECT m.* 
FROM dbo.member AS m
WHERE m.corp_no = 406
go

SELECT m.* 
FROM dbo.member AS m
WHERE m.corp_no = 407
go



--SELECT m.* 
--FROM dbo.member AS m
--WHERE m.corp_no = 202
--go

--SELECT m.* 
--FROM dbo.member AS m
--WHERE m.corp_no = 203
--go

--SELECT m.* 
--FROM dbo.member AS m
--WHERE m.corp_no = 204
--go

--SELECT m.* 
--FROM dbo.member AS m
--WHERE m.corp_no = 205
--go

--SELECT m.* 
--FROM dbo.member AS m
--WHERE m.corp_no = 364
--go

--SELECT m.* 
--FROM dbo.member AS m
--WHERE m.corp_no = 365
--go

--SELECT m.* 
--FROM dbo.member AS m
--WHERE m.corp_no = 366
--go

--SELECT m.* 
--FROM dbo.member AS m
--WHERE m.corp_no = 367
--go

-- Let's compare the density vector with 
-- one that doesn't include NULL values

CREATE STATISTICS GoodDensityVector
ON member (corp_no)
WHERE corp_no IS NOT NULL;
GO

DBCC SHOW_STATISTICS ('member', 'member_corporation_link');
DBCC SHOW_STATISTICS ('member', 'GoodDensityVector');
GO

-- At first glance they look the same... but, are they?
-- Remember, average is calculated as ALL DENSITY * ROWS

-- For the statistic on 'member_corporation_link':
SELECT 0.0025 * 10000 AS [Average # of Rows from member_corporation_link]

-- For the statistic on 'GoodDensityVector':
SELECT 0.002506266 * 1502 AS [Average # of Rows from GoodDensityVector]
GO

-- Is it true?
SELECT AVG([CountofCorps])
FROM (SELECT CONVERT(DECIMAL, COUNT(*)) AS [CountofCorps] 
	FROM member
	--WHERE corp_no IS NOT NULL
	GROUP BY corp_no) AS [Counts]

SELECT AVG([CountofCorps])
FROM (SELECT CONVERT(DECIMAL, COUNT(*)) AS [CountofCorps] 
	FROM member
	WHERE corp_no IS NOT NULL
	GROUP BY corp_no) AS [Counts]

